##############################################################################
# Sccsid:  @(#)  .../demo.4gm/report2.bak/report.4gl  1.1  Last Delta: 11/28/88
##############################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            customer_num like customer.customer_num,
            fname like customer.fname,
            company like customer.company,
            phone like customer.phone,
            order_num like orders.order_num,
            po_num like orders.po_num,
            order_date like orders.order_date,
            ship_date like orders.ship_date,
            paid_date like orders.paid_date
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        left margin    0
        right margin   80

    order external by rpt.customer_num, rpt.order_num

    format
        page header
            print
                column   1, today using "mm/dd/yy";
                let scratch = "CUSTOMER ORDER HISTORY LIST"
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
            print
                column   1, "Customer"
            print
                column   1, "Number",
                column  11, "Name",
                column  30, "Company",
                column  52, "Phone"
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"

        page trailer
            print
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"
            print
                column   1, pageno using "Page: <<<<";
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.customer_num
            if
                rpt.order_num is not null
             or rpt.po_num is not null
             or rpt.order_date is not null
             or rpt.ship_date is not null
             or rpt.paid_date is not null
            then
                let dynamic = true
                need 4 lines
            else
                let dynamic = false
            end if

            print
                column   1, rpt.customer_num using "####",
                column  11, rpt.fname,
                column  30, rpt.company,
                column  52, rpt.phone
            if dynamic
            then
                print
                    column   4, "Activity Report:"
            end if
            if dynamic
            then
                print
                    column   7, "Order #",
                    column  16, "PO #",
                    column  27, "Ordered",
                    column  41, "Shipped",
                    column  55, "Paid"
            end if
            if dynamic
            then
                print
                    column   7, "----------------------------------------",
                    column  47, "----------------------"
            end if

        on every row
            if
                rpt.order_num is not null
             or rpt.po_num is not null
             or rpt.order_date is not null
             or rpt.ship_date is not null
             or rpt.paid_date is not null
            then
                print
                    column   7, rpt.order_num using "<<<<<<<",
                    column  16, rpt.po_num,
                    column  27, rpt.order_date using "mm/dd/yyyy",
                    column  41, rpt.ship_date using "mmm dd, yyyy",
                    column  55, rpt.paid_date using "ddd mmm dd 'yy"
            end if

        after group of rpt.customer_num
            if
                rpt.order_num is not null
             or rpt.po_num is not null
             or rpt.order_date is not null
             or rpt.ship_date is not null
             or rpt.paid_date is not null
            then
                let dynamic = true
                need 2 lines
            else
                let dynamic = false
            end if

            if dynamic
            then
                print
                    column   7, "--- Number of orders: ",
                    column  29, group count(*) using "###",
                    column  34, "-----------------------------------"
            end if
            if dynamic
            then
                print
            end if

end report
# report1()

